/*
 * inflash.h
 *
 *  Created on: 2024624
 *      Author: psx
 */

#ifndef APP_INC_INFLASH_H_
#define APP_INC_INFLASH_H_

#include "debug.h"
#include "math.h"

#define softVer "SV01_24101501"


#pragma pack(push,1)

/* ֽǰֽں */
typedef struct _recv_config_info{
    uint8_t start_Flag[2];                  /* ʼ־ */
    /* SL */
    uint8_t address[7];                     /* ַ */
    uint8_t Access_Node_Type[2];            /* ڵ  */
    uint8_t Communication_Methods[2];       /* ͨŷʽ  */
    uint8_t gw485_Baud[4];                  /* ڲ */
    uint8_t bat485_Baud[4];                 /* ڲ,Ϊ0bms֧ͨ */

    /* HY */
    uint8_t hardwareID[6];                  /* ӲID */
    uint8_t communicationID[4];             /* ͨID */
    uint8_t protocolType;                   /* Э;  0x01ʾԴЭ(9600) 0x02ʾЭ(115200)*/


    uint8_t CommunicationProtocolType;      /* 0x00:SL
                                               0x01:HY*/
    uint8_t onlyPower;                      /* Ƿֻ䵱Դ壺0x00:
                                                          0x01*/

    uint8_t ConstantVoltageV[2];            /* ڸ(ѹ / 100)ҵFloatI * 100кѹ */
    uint8_t FloatI[2];                      /* ڸ(ѹ / 100)ҵFloatI * 100и */
    uint8_t startSolarOpenCircuitV[2];      /* ڸ(ѹ / 100)ʼ */
    uint8_t stopSolarOpenCircuitV[2];       /* ̫ܰ忪·ѹڸõѹֹͣ  (V) */
    uint8_t constantVoltageChargeV[2];      /* ѹʱѹ  (V) */
    uint8_t FloatChargeV[2];                /* ʱѹ  (V) */
    uint8_t HighSideMosTemperature_stop[2]; /* ¶ȴﵽֵʱֹͣ  (C) */
    uint8_t HighSideMosTemperature_end[2];  /* ¶ֵʱ͹  (C) */
    uint8_t HighSideMosTemperature_start[2];/* ¶Ƚ͵ֵʱ  (C) */
//    uint8_t loopImpedance[2];               /* ·迹С  () */
//    uint8_t totalElectricityConsumption[2]; /* ܵ */
//    uint8_t totalChargCapacity[2];          /* ܳ */

    uint8_t checkSolarOpenCircuitVTime[2];  /* ̫ܰ忪·ѹʱ  (S) */
//    uint8_t registerRefreshTime[2];         /* Ĵˢʱ (S) */
    uint8_t sensorEnableBroadcastTime[2];   /* ٴעļ (S) */
    uint8_t outputAgainFlagTime[2];         /* ֶ·ӳöʱٴμǷ·Ȼ·ر  (S) */
    uint8_t excessiveLoadFlagTime[2];       /* ֹغڸüʱжΣ2Σֹأر  (S) */
    uint8_t eLAgainTime[2];                 /* ֹعرڸüʱٴγ  (S) */
    uint8_t crc[2];                         /* У */
    uint8_t end_Flag;                       /* ־ */
}recv_config_info;
#define RECV_CONFIG_INFO sizeof(recv_config_info)

typedef struct _config_info{
    /* SL */
    uint8_t address[7];                     /* ַ */
    uint16_t Access_Node_Type;              /* ڵ  */
    uint16_t Communication_Methods;         /* ͨŷʽ  */
    uint32_t gw485_Baud;                    /* ڲ,Ϊ0bms֧ͨ */
    uint32_t bat485_Baud;                   /* ڲ */

    /* HY */
    uint8_t hardwareID[6];                  /* ӲID */
    uint8_t communicationID[4];             /* ͨID */
    uint8_t protocolType;                   /* Э;  0x01ʾԴЭ(9600) 0x02ʾЭ(115200)*/

    uint8_t CommunicationProtocolType;      /* 0x00:SL
                                               0x01:HY*/
    uint8_t onlyPower;                      /* Ƿֻ䵱Դ壺0x00:
                                                          0x01*/

    float_t constantVoltageV;               /* ѹConstantVoltageVҵFloatI + 0.1кѹ */
    float_t floatI;                         /* ѹConstantVoltageVҵFloatIи */
    float_t startSolarOpenCircuitV;         /* ̫ܰ忪·ѹڸõѹʼ */
    float_t stopSolarOpenCircuitV;          /* ̫ܰ忪·ѹڸõѹ ֹͣ */
    float_t constantVoltageChargeV;         /* ѹʱѹ */
    float_t FloatChargeV;                   /* ѹ */
    float_t HighSideMosTemperature_stop;    /* ¶ȴﵽֵʱֹͣ */
    float_t HighSideMosTemperature_end;     /* ¶ֵʱ͹ */
    float_t HighSideMosTemperature_start;   /* ¶Ƚ͵ֵʱ */
//    float_t loopImpedance;                  /* ·迹С  () */
//    float_t totalElectricityConsumption;    /* ܵ */
//    float_t totalChargCapacity;             /* ܳ */

    uint16_t checkSolarOpenCircuitVTime;    /* ̫ܰ忪·ѹʱ */
//    uint16_t registerRefreshTime;           /* Ĵˢʱ */
    uint16_t sensorEnableBroadcastTime;     /* ٴעļ */
    uint16_t outputAgainFlagTime;           /* ֶ·ӳöʱٴμǷ·Ȼ·ر */
    uint16_t excessiveLoadFlagTime;         /* ֹغڸöʱٴγֹأر */
    uint16_t eLAgainTime;                   /* ֹعر󣬸öʱٴγ */

    uint16_t crc;                           /* У */
}config_info;

#define CONFIG_INFO_SIZE    (sizeof(config_info))
#pragma pack(pop)


#define CONFIG_SAVE_addr            (0)
#define CONFIG_SAVE_ADDR_BEGIN      (CONFIG_INFO_SIZE)
#define CONFIG_SAVE_ADDR_END        (CONFIG_INFO_SIZE + CONFIG_INFO_SIZE)
#define LoopImpedance_SAVE_addr     (CONFIG_INFO_SIZE + CONFIG_INFO_SIZE + 10)
#define totalElectricityConsumption_SAVE_addr   (CONFIG_INFO_SIZE + CONFIG_INFO_SIZE + 20)
#define totalChargCapacity_SAVE_addr   (CONFIG_INFO_SIZE + CONFIG_INFO_SIZE + 30)

void save_config_info(config_info *save_config_info);
void read_config_info(config_info *output_config_info);
void checkFlashContent(void);
void config_info_start(void);
void read_and_process_config_data(void);

void saveLoopImpedance(float_t *loopImpedance);
void readLoopImpedance(float_t *loopImpedance);
void savetotalElectricityConsumption(float_t *totalElectricityConsumption);
void readtotalElectricityConsumption(float_t *totalElectricityConsumption);
void savetotalChargCapacity(float_t *totalChargCapacity);
void readtotalChargCapacity(float_t *totalChargCapacity);


extern uint16_t configCheckFunc(uint8_t *arr_buff, uint8_t len);

#endif /* APP_INC_INFLASH_H_ */
